%global commitId 45f7dd6a830bdaf7f55da72039c05be4c9cce26b
%define selinux_variants targeted
%define selinux_modules automation-platform
%define debug_package %{nil}

Name:           ansible-automation-platform-selinux
Version:        0.2
Release:        1%{?dist}
Summary:        SELinux policy for Ansible Automation Platform

License:        ASL 2.0
URL:            git@github.com:ansible/automation-platform-selinux
Source0:        ansible-automation-platform-selinux-45f7dd6a830bdaf7f55da72039c05be4c9cce26b.tar.gz

BuildRequires:  checkpolicy
BuildRequires:  selinux-policy-devel
BuildRequires:  systemd
Requires:       selinux-policy
Requires(post): policycoreutils
Requires(postun): policycoreutils
%{?systemd_requires}

%description
The SELinux policy for Ansible Automation Platform

%prep
%autosetup -n ansible-automation-platform-selinux-%{commitId}

%build
for selinuxvariant in %{selinux_variants}
do
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile
  for selinuxmodule in %{selinux_modules}
  do
    mv ${selinuxmodule}.pp ${selinuxmodule}.pp.${selinuxvariant}
  done
  make NAME=${selinuxvariant} -f /usr/share/selinux/devel/Makefile clean
done


%install
for selinuxvariant in %{selinux_variants}
do
  install -d %{buildroot}%{_datadir}/selinux/${selinuxvariant}
  for selinuxmodule in %{selinux_modules}
  do
    install -p -m 644 ${selinuxmodule}.pp.${selinuxvariant} \
      %{buildroot}%{_datadir}/selinux/${selinuxvariant}/${selinuxmodule}.pp
  done
done

%post
for selinuxvariant in %{selinux_variants}
do
  /usr/sbin/semodule -s ${selinuxvariant} -r tower &> /dev/null || :
  /usr/sbin/semodule -s ${selinuxvariant} -r automation-controller &> /dev/null || :
  for selinuxmodule in %{selinux_modules}
  do
    /usr/sbin/semodule -s ${selinuxvariant} -i \
      %{_datadir}/selinux/${selinuxvariant}/${selinuxmodule}.pp &> /dev/null || :
    if %{_sbindir}/selinuxenabled ; then
      %{_sbindir}/load_policy
      /sbin/restorecon -Ri /var/lib/awx/venv /var/lib/awx/job_status /var/run/tower /var/run/ansible-automation-platform &>/dev/null || :
    fi
  done
done
systemctl daemon-reexec &>/dev/null || :

%postun
if [ $1 -eq 0 ] ; then
  for selinuxvariant in %{selinux_variants}
  do
    for selinuxmodule in %{selinux_modules}
    do
      /usr/sbin/semodule -s ${selinuxvariant} -r ${selinuxmodule} &> /dev/null || :
    if %{_sbindir}/selinuxenabled ; then
      %{_sbindir}/load_policy
      /sbin/restorecon -Ri /var/lib/awx/venv /var/lib/awx/job_status /var/run/tower /var/run/ansible-automation-platform &>/dev/null || :
    fi
    done
  done
  systemctl daemon-reexec &>/dev/null || :
fi

%files
%defattr(-,root,root,0755)
%{_datadir}/selinux/*/automation-platform.pp


%changelog
* Mon May 16 2022 Yanis Guenane <yguenane@redhat.com> - 0.2.1
- Build automation-platform 0.2 policy

* Mon May 16 2022 Yanis Guenane <yguenane@redhat.com> - 0.1-4
- Only build for target variant

* Mon May 16 2022 Yanis Guenane <yguenane@redhat.com> - 0.1-3
- Reload policy after install

* Thu May 05 2022 Yanis Guenane <yguenane@redhat.com> - 0.1-2
- Release ansible-automation-platform-selinux 0.1
